#include <windows.h>
#include <stdio.h>
#include "resource.h"

// Global...
HHOOK hkmm;

// from scooper "common.c".
HMENU MenuToPopup(HMENU hm)
{
	HMENU hpopup;
	UINT i, max;

	hpopup = CreatePopupMenu();
	max = GetMenuItemCount(hm);
	for(i = 0; i < max; i++)
	{
		MENUITEMINFO mii;
		TCHAR ts[256];

		mii.cbSize = sizeof(mii);
		mii.fMask = MIIM_CHECKMARKS | MIIM_DATA | MIIM_ID | MIIM_STATE | MIIM_SUBMENU | MIIM_TYPE;
		mii.fType = MFT_STRING;	// TODO: ?
		mii.dwTypeData = ts;
		mii.cch = sizeof(ts) - 2;
		/*
		mii.fState = 0;
		mii.wID = 0;
		mii.hSubMenu = NULL;
		mii.hbmpChecked = NULL;
		mii.hbmpUnchecked = NULL;
		mii.dwItemData = 0;
		*/

		GetMenuItemInfo(hm, i, TRUE, &mii);
		InsertMenuItem(hpopup, i, TRUE, &mii);
	}

	DestroyMenu(hm);

	return hpopup;
}

void trayicon(DWORD act, HWND hWnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize = sizeof(nid);
	nid.hWnd = hWnd;
	nid.uID = 0;
	if(act == NIM_ADD)
	{
		nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		nid.hIcon = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		nid.uCallbackMessage = WM_APP;
		strcpy(nid.szTip, "thinbar");
	}
	Shell_NotifyIcon(act, &nid);

	return;
}

HWND hook()
{
	HMODULE hmod;
	HWND taskwnd;
	HHOOK hk;
	DWORD tid;
	HOOKPROC fucker;

	if(!(hmod = LoadLibrary("thindll.dll")))
		return NULL;
	if(!(taskwnd = FindWindow("Shell_TrayWnd", NULL)))
		return NULL;
	if(!(tid = GetWindowThreadProcessId(taskwnd, NULL)))
		return NULL;
	if(!(fucker = (HOOKPROC)GetProcAddress(hmod, "_ExplorerFucker@12")))	// stdcall
		return NULL;
	if(!(hk = SetWindowsHookEx(WH_CALLWNDPROC, fucker, hmod, tid)))
		return NULL;
	SendMessage(taskwnd, WM_NULL, 'THiN', (LPARAM)hk);
	if(!(fucker = (HOOKPROC)GetProcAddress(hmod, "_ExplorerKicker@12")))	// stdcall
		return NULL;
	if(!(hkmm = SetWindowsHookEx(WH_GETMESSAGE, fucker, hmod, tid)))
		return NULL;

	return taskwnd;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static UINT taskrebirth = WM_NULL;

	if(msg == taskrebirth)
	{
		HWND hwnd;

		hwnd = hook();
		trayicon(NIM_ADD, hWnd);
		PostMessage(hWnd, WM_NULL, 'HooK', (LONG)hwnd);
	}

	switch(msg)
	{
	case WM_CREATE:
		trayicon(NIM_ADD, hWnd);

		taskrebirth = RegisterWindowMessage("TaskbarCreated");

		break;
	case WM_APP:
		if(wParam == 0)	// ID:0
		{
			switch(lParam)
			{
			case WM_RBUTTONDOWN:
			case WM_CONTEXTMENU:
				{
					HMENU hm;
					POINT p;

					GetCursorPos(&p);
					SetActiveWindow(hWnd);
					SetForegroundWindow(hWnd);
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_TRAYMENU)));
					TrackPopupMenu(hm, 0, p.x, p.y, 0, hWnd, NULL);
				}
			//case WM_LBUTTONDBLCLK:
				//DestroyWindow(hWnd);
				break;
			}
		}
		break;
	case WM_COMMAND:
		switch(wParam)
		{
		case ID_ABOUT:
			MessageBox(hWnd, "Thinbar - flying taskbar\n by Murachue\n  version: see exe's resource...", "About Thinbar", MB_ICONASTERISK | MB_OK);
			break;
		case ID_QUIT:
			DestroyWindow(hWnd);
			break;
		}
		break;
	case WM_CLOSE:
		break;
	case WM_DESTROY:
		trayicon(NIM_DELETE, hWnd);
		PostQuitMessage(0);
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmd, int nShowCmd)
{
	WNDCLASSEX wc = {0};
	HWND hMainWnd;
	MSG msg;

	wc.cbSize = sizeof(wc);
	wc.hInstance = hInst;
	wc.lpfnWndProc = MainWndProc;
	wc.lpszClassName = "thinbarMainWndClass";
	if(!RegisterClassEx(&wc))
		return 1;

	if(!(hMainWnd = CreateWindowEx(0, wc.lpszClassName, "thinbarTasktrayWnd", 0, 0, 0 ,0, 0, NULL, 0, hInst, NULL)))
		return 2;

	{
		HWND taskwnd = hook();

		__try
		{
			while(GetMessage(&msg, NULL, 0, 0))
			{
				if(msg.message == WM_NULL && msg.wParam == 'HooK')
					taskwnd = (HWND)msg.lParam;
				DispatchMessage(&msg);
			}
		}__except(EXCEPTION_EXECUTE_HANDLER)
		{
			// die soft.
			char ts[256];

			sprintf(ts, "FATAL EXCEPTION: %08X\nthinbar WILL QUIT NOW!", GetExceptionCode());
			MessageBox(NULL, ts, "thinbar: Fatal error", MB_ICONERROR | MB_OK);
		}

		SendMessage(taskwnd, WM_NULL, '', (LONG)'');
		UnhookWindowsHookEx(hkmm);	// MouseMove watcher is safe to remove anytime!
	}

	return 0;
}
